# -*- coding: utf-8 -*-
##############################################################################
#    
#    VNC Developments (India) Pvt. Ltd.
#    Copyright (C) 2004-TODAY VNC (<http://www.vnc.biz>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
#
##############################################################################

from osv import osv, fields

class product_product(osv.osv):
    _inherit = 'product.product'
    _columns = {
                'cost_method': fields.selection([
                                                 ('standard','Standard Price'),
                                                 ('average','Average Price'),
                                                 ('lifo', 'LiFo'),
                                                 ('fifo', 'FiFo'),
                                                ], 'Costing Method', required=True,
                                    help="Standard Price: the cost price is fixed and recomputed periodically (usually at the end of the year), Average Price: the cost price is recomputed at each reception of products."),
                }

    def onchange_cost_method(self, cr, uid, ids, cost_method):
        res = {}
        if cost_method and cost_method in ['fifo','lifo']:
            res['value'] = {'track_production': True,'track_incoming': True, 'track_outgoing': True}
        else:
            res['value'] = {'track_production': False,'track_incoming': False, 'track_outgoing': False}
        return res

    def get_stock_controling(self, cr, uid, product_id, product_uom, product_qty, location_id):
        res = []
        context = {'location_id' : location_id}
        product_obj = self.browse(cr, uid, product_id, context=context)
        dic = {}
        stock_type = product_obj.cost_method == 'lifo' and 'desc' or 'asc'
        
        prod_id = self.pool.get('stock.production.lot').search(cr, uid,
                       [('product_id','=',product_id), ('stock_available','>',0.0)],
                       order='date %s'%(stock_type),
                       context=context)

        total = 0
        for prod_obj in self.pool.get('stock.production.lot').browse(cr, uid, prod_id, context=context):
            if total == product_qty:
                break
            if prod_obj.stock_available+total > product_qty:
                res.append([prod_obj.id, product_qty - total])
                total += product_qty - total
                break
            total += prod_obj.stock_available
            res.append([prod_obj.id, prod_obj.stock_available])

        return res

product_product()
